package net.mcreator.projectomega.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.projectomega.entity.MechaAutomatonEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class MechaAutomatonRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(MechaAutomatonEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new ModelMechaAutomaton(), 0.5f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("project_omega:textures/mechaautomaton2.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 3.5.4
	// Exported for Minecraft version 1.15
	// Paste this class into your mod and generate all required imports
	public static class ModelMechaAutomaton extends EntityModel<Entity> {
		private final ModelRenderer LeftLeg;
		private final ModelRenderer RightLeg;
		private final ModelRenderer Body;
		private final ModelRenderer Arms;
		private final ModelRenderer Head;
		public ModelMechaAutomaton() {
			textureWidth = 16;
			textureHeight = 16;
			LeftLeg = new ModelRenderer(this);
			LeftLeg.setRotationPoint(3.0F, 23.0F, 0.0F);
			LeftLeg.setTextureOffset(6, 4).addBox(-1.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			LeftLeg.setTextureOffset(6, 0).addBox(-1.0F, -1.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			LeftLeg.setTextureOffset(0, 6).addBox(-1.0F, -2.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			LeftLeg.setTextureOffset(3, 3).addBox(-1.0F, 0.0F, 1.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			LeftLeg.setTextureOffset(0, 2).addBox(0.0F, 0.0F, 1.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			LeftLeg.setTextureOffset(0, 0).addBox(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			RightLeg = new ModelRenderer(this);
			RightLeg.setRotationPoint(5.0F, 23.0F, 0.0F);
			RightLeg.setTextureOffset(6, 2).addBox(-7.0F, -1.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			RightLeg.setTextureOffset(3, 7).addBox(-7.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			RightLeg.setTextureOffset(6, 6).addBox(-7.0F, -2.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			RightLeg.setTextureOffset(3, 5).addBox(-7.0F, 0.0F, 1.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			RightLeg.setTextureOffset(0, 4).addBox(-8.0F, 0.0F, 1.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			RightLeg.setTextureOffset(3, 1).addBox(-8.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			Body = new ModelRenderer(this);
			Body.setRotationPoint(0.0F, 24.0F, 0.0F);
			Body.setTextureOffset(0, 0).addBox(-2.0F, -4.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			Body.setTextureOffset(0, 0).addBox(-1.0F, -4.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			Body.setTextureOffset(0, 0).addBox(0.0F, -4.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			Body.setTextureOffset(0, 0).addBox(1.0F, -4.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			Body.setTextureOffset(0, 0).addBox(2.0F, -4.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			Body.setTextureOffset(0, 0).addBox(-2.0F, -10.0F, -1.0F, 5.0F, 6.0F, 3.0F, 0.0F, false);
			Arms = new ModelRenderer(this);
			Arms.setRotationPoint(0.0F, 24.0F, 0.0F);
			Arms.setTextureOffset(0, 0).addBox(-3.0F, -9.0F, 0.0F, 1.0F, 4.0F, 1.0F, 0.0F, false);
			Arms.setTextureOffset(0, 0).addBox(3.0F, -9.0F, 0.0F, 1.0F, 4.0F, 1.0F, 0.0F, false);
			Head = new ModelRenderer(this);
			Head.setRotationPoint(0.0F, 24.0F, 0.0F);
			Head.setTextureOffset(0, 0).addBox(-1.0F, -13.0F, 0.0F, 3.0F, 3.0F, 1.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			LeftLeg.render(matrixStack, buffer, packedLight, packedOverlay);
			RightLeg.render(matrixStack, buffer, packedLight, packedOverlay);
			Body.render(matrixStack, buffer, packedLight, packedOverlay);
			Arms.render(matrixStack, buffer, packedLight, packedOverlay);
			Head.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.LeftLeg.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.Head.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.Head.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.RightLeg.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.Arms.rotateAngleX = MathHelper.cos(f * 0.6662F + (float) Math.PI) * f1;
		}
	}
}
