
package net.mcreator.projectomega.item;

import net.minecraftforge.registries.ObjectHolder;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.World;
import net.minecraft.util.ResourceLocation;
import net.minecraft.item.crafting.Ingredient;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.item.IArmorMaterial;
import net.minecraft.item.ArmorItem;
import net.minecraft.inventory.EquipmentSlotType;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.Entity;

import net.mcreator.projectomega.procedures.EnergyArmorBootsProcedureProcedure;
import net.mcreator.projectomega.ProjectOmegaModElements;

import java.util.Map;
import java.util.HashMap;

@ProjectOmegaModElements.ModElement.Tag
public class EnergyArmorItem extends ProjectOmegaModElements.ModElement {
	@ObjectHolder("project_omega:energy_armor_helmet")
	public static final Item helmet = null;
	@ObjectHolder("project_omega:energy_armor_chestplate")
	public static final Item body = null;
	@ObjectHolder("project_omega:energy_armor_leggings")
	public static final Item legs = null;
	@ObjectHolder("project_omega:energy_armor_boots")
	public static final Item boots = null;
	public EnergyArmorItem(ProjectOmegaModElements instance) {
		super(instance, 13);
	}

	@Override
	public void initElements() {
		IArmorMaterial armormaterial = new IArmorMaterial() {
			@Override
			public int getDurability(EquipmentSlotType slot) {
				return new int[]{13, 15, 16, 11}[slot.getIndex()] * 25;
			}

			@Override
			public int getDamageReductionAmount(EquipmentSlotType slot) {
				return new int[]{7, 11, 12, 8}[slot.getIndex()];
			}

			@Override
			public int getEnchantability() {
				return 4;
			}

			@Override
			public net.minecraft.util.SoundEvent getSoundEvent() {
				return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation(""));
			}

			@Override
			public Ingredient getRepairMaterial() {
				return Ingredient.fromStacks(new ItemStack(MechaBatteryItem.block));
			}

			@OnlyIn(Dist.CLIENT)
			@Override
			public String getName() {
				return "energy_armor";
			}

			@Override
			public float getToughness() {
				return 2.3f;
			}

			@Override
			public float getKnockbackResistance() {
				return 0.3f;
			}
		};
		elements.items
				.add(() -> new ArmorItem(armormaterial, EquipmentSlotType.HEAD, new Item.Properties().group(ItemGroup.COMBAT).isImmuneToFire()) {
					@Override
					public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlotType slot, String type) {
						return "project_omega:textures/models/armor/energyarmortexture1_layer_" + (slot == EquipmentSlotType.LEGS ? "2" : "1")
								+ ".png";
					}

					@Override
					public void onArmorTick(ItemStack itemstack, World world, PlayerEntity entity) {
						super.onArmorTick(itemstack, world, entity);
						double x = entity.getPosX();
						double y = entity.getPosY();
						double z = entity.getPosZ();
						{
							Map<String, Object> $_dependencies = new HashMap<>();
							$_dependencies.put("entity", entity);
							EnergyArmorBootsProcedureProcedure.executeProcedure($_dependencies);
						}
					}
				}.setRegistryName("energy_armor_helmet"));
		elements.items
				.add(() -> new ArmorItem(armormaterial, EquipmentSlotType.CHEST, new Item.Properties().group(ItemGroup.COMBAT).isImmuneToFire()) {
					@Override
					public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlotType slot, String type) {
						return "project_omega:textures/models/armor/energyarmortexture1_layer_" + (slot == EquipmentSlotType.LEGS ? "2" : "1")
								+ ".png";
					}

					@Override
					public void onArmorTick(ItemStack itemstack, World world, PlayerEntity entity) {
						double x = entity.getPosX();
						double y = entity.getPosY();
						double z = entity.getPosZ();
						{
							Map<String, Object> $_dependencies = new HashMap<>();
							$_dependencies.put("entity", entity);
							EnergyArmorBootsProcedureProcedure.executeProcedure($_dependencies);
						}
					}
				}.setRegistryName("energy_armor_chestplate"));
		elements.items
				.add(() -> new ArmorItem(armormaterial, EquipmentSlotType.LEGS, new Item.Properties().group(ItemGroup.COMBAT).isImmuneToFire()) {
					@Override
					public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlotType slot, String type) {
						return "project_omega:textures/models/armor/energyarmortexture1_layer_" + (slot == EquipmentSlotType.LEGS ? "2" : "1")
								+ ".png";
					}

					@Override
					public void onArmorTick(ItemStack itemstack, World world, PlayerEntity entity) {
						double x = entity.getPosX();
						double y = entity.getPosY();
						double z = entity.getPosZ();
						{
							Map<String, Object> $_dependencies = new HashMap<>();
							$_dependencies.put("entity", entity);
							EnergyArmorBootsProcedureProcedure.executeProcedure($_dependencies);
						}
					}
				}.setRegistryName("energy_armor_leggings"));
		elements.items
				.add(() -> new ArmorItem(armormaterial, EquipmentSlotType.FEET, new Item.Properties().group(ItemGroup.COMBAT).isImmuneToFire()) {
					@Override
					public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlotType slot, String type) {
						return "project_omega:textures/models/armor/energyarmortexture1_layer_" + (slot == EquipmentSlotType.LEGS ? "2" : "1")
								+ ".png";
					}

					@Override
					public void onArmorTick(ItemStack itemstack, World world, PlayerEntity entity) {
						double x = entity.getPosX();
						double y = entity.getPosY();
						double z = entity.getPosZ();
						{
							Map<String, Object> $_dependencies = new HashMap<>();
							$_dependencies.put("entity", entity);
							EnergyArmorBootsProcedureProcedure.executeProcedure($_dependencies);
						}
					}
				}.setRegistryName("energy_armor_boots"));
	}
}
